#pragma once

#ifndef __AFXWIN_H__
  #error "include 'stdafx.h' before including this file for PCH"
#endif //#ifndef __AFXWIN_H__

#include "resource.h"


class CPyDebugPPApp : public CWinAppEx
{
public:
//Constructors / Destructors
  CPyDebugPPApp();
  CPyDebugPPApp(const CPyDebugPPApp&) = delete;
  CPyDebugPPApp(CPyDebugPPApp&&) = delete;
  ~CPyDebugPPApp() = default; //NOLINT(modernize-use-override)

//Methods
  CPyDebugPPApp& operator=(const CPyDebugPPApp&) = delete;
  CPyDebugPPApp& operator=(CPyDebugPPApp&&) = delete;

//Member variables
  Lexilla::CreateLexerFn m_pCreateLexer;

protected:
//Member variables
  HINSTANCE m_hScintilla;
  HINSTANCE m_hLexilla;
  PyThreadState* m_pPythonThreadState;
  PyConfig m_pyConfig;

//Methods
  HMODULE LoadLibraryFromApplicationDirectory(_In_z_ LPCTSTR lpFileName);
  BOOL InitInstance() override;
  int ExitInstance() override;

//Message handler
  afx_msg void OnAppAbout();

  DECLARE_MESSAGE_MAP()
};

extern CPyDebugPPApp theApp;
