#pragma once

#ifndef VC_EXTRALEAN
#define VC_EXTRALEAN //Exclude rarely-used stuff from Windows headers
#endif

#include "targetver.h"

#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS //some CString constructors will be explicit
#define _AFX_ALL_WARNINGS //turns off MFC's hiding of some common and often safely ignored warning messages

#include <afxwin.h> //MFC core and standard components
#include <afxext.h> //MFC extensions
#ifndef _AFX_NO_OLE_SUPPORT
#include <afxdtctl.h> //MFC support for Internet Explorer 4 Common Controls
#endif
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h> // MFC support for Windows Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT
#include <afxcontrolbars.h> // MFC support for ribbons and control bars
#include <TlHelp32.h>

//STL support
#include <atomic>
#include <vector>
#include <deque>
#include <algorithm>
#include <memory>
#include <string_view>
#include <array>

//Pull in support for Scintilla \ Lexilla
#pragma warning(push)
#pragma warning(disable: 26812)
#include <ScintillaTypes.h>
#include <ScintillaCall.h>
#include <ScintillaMessages.h>
#include <ScintillaStructures.h>
#include <ILexer.h>
#include <Lexilla.h>
#include <SciLexer.h>
#pragma warning(pop)

//Pull in support for Python
#pragma warning(push)
#pragma warning(disable: 26446 26461 26462 26476 26477 26482 26485 26486 26487 26489 26494 26496)
#include <Python.h>
#include <frameobject.h>
#pragma warning(pop)

#ifdef _UNICODE
#if defined _M_IX86
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_X64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#else
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif //#if defined _M_IX86
#endif //#ifdef _UNICODE
