/*
Module : PyDebugThread.h
Purpose: Defines the interface for the classes which encapsulate Threads functionality of PyDebug++
Created: PJN / 20-08-2015

Copyright (c) 2015 - 2023 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once

#ifndef __PYDEBUGTHREAD_H__
#define __PYDEBUGTHREAD_H__

#ifndef CPYDEBUG_EXT_CLASS
#define CPYDEBUG_EXT_CLASS
#endif //#ifndef CPYDEBUG_EXT_CLASS


//////////////////// Classes //////////////////////////////////////////////////

class CPYDEBUG_EXT_CLASS CPyDebugThread
{
public:
//Member variables
  DWORD m_dwThreadID{0};
  int m_nPriority{THREAD_BASE_PRIORITY_MIN - 1};
  bool m_bHit{false};
};


#endif //#ifndef __PYDEBUGTHREAD_H__
